Open CASCADE Technology: TopoDS_Shape Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
TopoDS_Shape Class Reference

Describes a shape which. More...

`#include <TopoDS_Shape.hxx>`

Inheritance diagram for TopoDS_Shape:
[legend]

## Public Member Functions
| TopoDS_Shape ()
| Creates a NULL Shape referring to nothing. More...
Standard_Boolean | IsNull () const
| Returns true if this shape is null. In other words, it references no underlying shape with the potential to be given a location and an orientation. More...
void | Nullify ()
| Destroys the reference to the underlying shape stored in this shape. As a result, this shape becomes null. More...
const TopLoc_Location & | Location () const
| Returns the shape local coordinate system. More...
void | Location (const TopLoc_Location &Loc)
| Sets the shape local coordinate system. More...
TopoDS_Shape | Located (const TopLoc_Location &Loc) const
| Returns a shape similar to <me> with the local coordinate system set to <Loc>. More...
TopAbs_Orientation | Orientation () const
| Returns the shape orientation. More...
void | Orientation (const TopAbs_Orientation Orient)
| Sets the shape orientation. More...
TopoDS_Shape | Oriented (const TopAbs_Orientation Or) const
| Returns a shape similar to <me> with the orientation set to <Or>. More...
const Handle< TopoDS_TShape > & | TShape () const
TopAbs_ShapeEnum | ShapeType () const
| Returns the value of the TopAbs_ShapeEnum enumeration that corresponds to this shape, for example VERTEX, EDGE, and so on. Exceptions Standard_NullObject if this shape is null. More...
Standard_Boolean | Free () const
| Returns the free flag. More...
void | Free (const Standard_Boolean F)
| Sets the free flag. More...
Standard_Boolean | Locked () const
| Returns the locked flag. More...
void | Locked (const Standard_Boolean F)
| Sets the locked flag. More...
Standard_Boolean | Modified () const
| Returns the modification flag. More...
void | Modified (const Standard_Boolean M)
| Sets the modification flag. More...
Standard_Boolean | Checked () const
| Returns the checked flag. More...
void | Checked (const Standard_Boolean C)
| Sets the checked flag. More...
Standard_Boolean | Orientable () const
| Returns the orientability flag. More...
void | Orientable (const Standard_Boolean C)
| Sets the orientability flag. More...
Standard_Boolean | Closed () const
| Returns the closedness flag. More...
void | Closed (const Standard_Boolean C)
| Sets the closedness flag. More...
Standard_Boolean | Infinite () const
| Returns the infinity flag. More...
void | Infinite (const Standard_Boolean C)
| Sets the infinity flag. More...
Standard_Boolean | Convex () const
| Returns the convexness flag. More...
void | Convex (const Standard_Boolean C)
| Sets the convexness flag. More...
void | Move (const TopLoc_Location &position)
| Multiplies the Shape location by <position>. More...
TopoDS_Shape | Moved (const TopLoc_Location &position) const
| Returns a shape similar to <me> with a location multiplied by <position>. More...
void | Reverse ()
| Reverses the orientation, using the Reverse method from the TopAbs package. More...
TopoDS_Shape | Reversed () const
| Returns a shape similar to <me> with the orientation reversed, using the Reverse method from the TopAbs package. More...
void | Complement ()
| Complements the orientation, using the Complement method from the TopAbs package. More...
TopoDS_Shape | Complemented () const
| Returns a shape similar to <me> with the orientation complemented, using the Complement method from the TopAbs package. More...
void | Compose (const TopAbs_Orientation Orient)
| Updates the Shape Orientation by composition with <Orient>, using the Compose method from the TopAbs package. More...
TopoDS_Shape | Composed (const TopAbs_Orientation Orient) const
| Returns a shape similar to <me> with the orientation composed with <Orient>, using the Compose method from the TopAbs package. More...
Standard_Boolean | IsPartner (const TopoDS_Shape &other) const
| Returns True if two shapes are partners, i.e. if they share the same TShape. Locations and Orientations may differ. More...
Standard_Boolean | IsSame (const TopoDS_Shape &other) const
| Returns True if two shapes are same, i.e. if they share the same TShape with the same Locations. Orientations may differ. More...
Standard_Boolean | IsEqual (const TopoDS_Shape &other) const
| Returns True if two shapes are equal, i.e. if they share the same TShape with the same Locations and Orientations. More...
Standard_Boolean | operator== (const TopoDS_Shape &other) const
Standard_Boolean | IsNotEqual (const TopoDS_Shape &other) const
| Negation of the IsEqual method. More...
Standard_Boolean | operator!= (const TopoDS_Shape &other) const
Standard_Integer | HashCode (const Standard_Integer Upper) const
| Returns a hashed value denoting <me>. This value is in the range 1..<Upper>. It is computed from the TShape and the Location. The Orientation is not used. More...
void | EmptyCopy ()
| Replace <me> by a new Shape with the same Orientation and Location and a new TShape with the same geometry and no sub-shapes. More...
TopoDS_Shape | EmptyCopied () const
| Returns a new Shape with the same Orientation and Location and a new TShape with the same geometry and no sub-shapes. More...
void | TShape (const Handle< TopoDS_TShape > &T)

## Detailed Description

Describes a shape which.

- references an underlying shape with the potential to be given a location and an orientation
- has a location for the underlying shape, giving its placement in the local coordinate system
- has an orientation for the underlying shape, in terms of its geometry (as opposed to orientation in relation to other shapes). Note: A Shape is empty if it references an underlying shape which has an empty list of shapes.

## Constructor & Destructor Documentation

TopoDS_Shape::TopoDS_Shape | ( |  | ) |

Creates a NULL Shape referring to nothing.

## Member Function Documentation

Standard_Boolean TopoDS_Shape::Checked | ( |  | ) | const

Returns the checked flag.

void TopoDS_Shape::Checked | ( | const Standard_Boolean | C | ) |

Sets the checked flag.

Standard_Boolean TopoDS_Shape::Closed | ( |  | ) | const

Returns the closedness flag.

void TopoDS_Shape::Closed | ( | const Standard_Boolean | C | ) |

Sets the closedness flag.

void TopoDS_Shape::Complement | ( |  | ) |

Complements the orientation, using the Complement method from the TopAbs package.

TopoDS_Shape TopoDS_Shape::Complemented | ( |  | ) | const

Returns a shape similar to <me> with the orientation complemented, using the Complement method from the TopAbs package.

void TopoDS_Shape::Compose | ( | const TopAbs_Orientation | Orient | ) |

Updates the Shape Orientation by composition with <Orient>, using the Compose method from the TopAbs package.

TopoDS_Shape TopoDS_Shape::Composed | ( | const TopAbs_Orientation | Orient | ) | const

Returns a shape similar to <me> with the orientation composed with <Orient>, using the Compose method from the TopAbs package.

Standard_Boolean TopoDS_Shape::Convex | ( |  | ) | const

Returns the convexness flag.

void TopoDS_Shape::Convex | ( | const Standard_Boolean | C | ) |

Sets the convexness flag.

TopoDS_Shape TopoDS_Shape::EmptyCopied | ( |  | ) | const

Returns a new Shape with the same Orientation and Location and a new TShape with the same geometry and no sub-shapes.

void TopoDS_Shape::EmptyCopy | ( |  | ) |

Replace <me> by a new Shape with the same Orientation and Location and a new TShape with the same geometry and no sub-shapes.

Standard_Boolean TopoDS_Shape::Free | ( |  | ) | const

Returns the free flag.

void TopoDS_Shape::Free | ( | const Standard_Boolean | F | ) |

Sets the free flag.

Standard_Integer TopoDS_Shape::HashCode | ( | const Standard_Integer | Upper | ) | const

Returns a hashed value denoting <me>. This value is in the range 1..<Upper>. It is computed from the TShape and the Location. The Orientation is not used.

Standard_Boolean TopoDS_Shape::Infinite | ( |  | ) | const

Returns the infinity flag.

void TopoDS_Shape::Infinite | ( | const Standard_Boolean | C | ) |

Sets the infinity flag.

Standard_Boolean TopoDS_Shape::IsEqual | ( | const TopoDS_Shape & | other | ) | const

Returns True if two shapes are equal, i.e. if they share the same TShape with the same Locations and Orientations.

Standard_Boolean TopoDS_Shape::IsNotEqual | ( | const TopoDS_Shape & | other | ) | const

Negation of the IsEqual method.

Standard_Boolean TopoDS_Shape::IsNull | ( |  | ) | const

Returns true if this shape is null. In other words, it references no underlying shape with the potential to be given a location and an orientation.

Standard_Boolean TopoDS_Shape::IsPartner | ( | const TopoDS_Shape & | other | ) | const

Returns True if two shapes are partners, i.e. if they share the same TShape. Locations and Orientations may differ.

Standard_Boolean TopoDS_Shape::IsSame | ( | const TopoDS_Shape & | other | ) | const

Returns True if two shapes are same, i.e. if they share the same TShape with the same Locations. Orientations may differ.

TopoDS_Shape TopoDS_Shape::Located | ( | const TopLoc_Location & | Loc | ) | const

Returns a shape similar to <me> with the local coordinate system set to <Loc>.

const TopLoc_Location& TopoDS_Shape::Location | ( |  | ) | const

Returns the shape local coordinate system.

void TopoDS_Shape::Location | ( | const TopLoc_Location & | Loc | ) |

Sets the shape local coordinate system.

Standard_Boolean TopoDS_Shape::Locked | ( |  | ) | const

Returns the locked flag.

void TopoDS_Shape::Locked | ( | const Standard_Boolean | F | ) |

Sets the locked flag.

Standard_Boolean TopoDS_Shape::Modified | ( |  | ) | const

Returns the modification flag.

void TopoDS_Shape::Modified | ( | const Standard_Boolean | M | ) |

Sets the modification flag.

void TopoDS_Shape::Move | ( | const TopLoc_Location & | position | ) |

Multiplies the Shape location by <position>.

TopoDS_Shape TopoDS_Shape::Moved | ( | const TopLoc_Location & | position | ) | const

Returns a shape similar to <me> with a location multiplied by <position>.

void TopoDS_Shape::Nullify | ( |  | ) |

Destroys the reference to the underlying shape stored in this shape. As a result, this shape becomes null.

Standard_Boolean TopoDS_Shape::operator!= | ( | const TopoDS_Shape & | other | ) | const
| inline

Standard_Boolean TopoDS_Shape::operator== | ( | const TopoDS_Shape & | other | ) | const
| inline

Standard_Boolean TopoDS_Shape::Orientable | ( |  | ) | const

Returns the orientability flag.

void TopoDS_Shape::Orientable | ( | const Standard_Boolean | C | ) |

Sets the orientability flag.

TopAbs_Orientation TopoDS_Shape::Orientation | ( |  | ) | const

Returns the shape orientation.

void TopoDS_Shape::Orientation | ( | const TopAbs_Orientation | Orient | ) |

Sets the shape orientation.

TopoDS_Shape TopoDS_Shape::Oriented | ( | const TopAbs_Orientation | Or | ) | const

Returns a shape similar to <me> with the orientation set to <Or>.

void TopoDS_Shape::Reverse | ( |  | ) |

Reverses the orientation, using the Reverse method from the TopAbs package.

TopoDS_Shape TopoDS_Shape::Reversed | ( |  | ) | const

Returns a shape similar to <me> with the orientation reversed, using the Reverse method from the TopAbs package.

TopAbs_ShapeEnum TopoDS_Shape::ShapeType | ( |  | ) | const

Returns the value of the TopAbs_ShapeEnum enumeration that corresponds to this shape, for example VERTEX, EDGE, and so on. Exceptions Standard_NullObject if this shape is null.

const Handle< TopoDS_TShape >& TopoDS_Shape::TShape | ( |  | ) | const

void TopoDS_Shape::TShape | ( | const Handle< TopoDS_TShape > & | T | ) |

The documentation for this class was generated from the following file:

- TopoDS_Shape.hxx